<template>
  <div v-if="token">
    <Chat />
  </div>
</template>

<script lang="ts">
import Chat from "@/view/Chat.vue";
import { $auth0 } from "@/auth0";
import { reactive, toRefs, defineComponent, onBeforeMount, ref } from "vue";
import { store } from "@/store";

export default defineComponent({
  name: "App",
  components: {
    Chat,
  },
  setup() {
    function login() {
      $auth0.client.loginWithRedirect({
        appState: { targetUrl: window.location.href },
      });
    }

    if (!$auth0.state.isAuthenticated) login();
    else {
      $auth0.client.getIdTokenClaims().then((value: any) => {
        store.mutations.setToken(value.__raw);
        store.actions.getCurrentUser().then((value) => {
          if (!value) {
            store.actions.createUserByToken().then(() => {
              store.actions.getAllUser();
              store.actions
                .getCurrentUser()
                .then((value) => store.mutations.setUser(value));
            });
            return;
          }
          store.mutations.setUser(value);
        });
      });
    }

    const { token } = toRefs(store.state);
    return { token };
  },
});
</script>

<style>
body,
html {
  --tw-bg-opacity: 1;
  background-color: rgba(31, 41, 55, var(--tw-bg-opacity));
}
img, video {
    max-width: 100%;
    height: fit-content !important;
}
</style>
